 

 function [SensorNet,areaNet,poorareaNet,territoryArea]=WsnNet(AreaSize,AreaSide,netSize,territorySize,territorySide) 


  
 
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%-----------node area-----------%%%%%%%%%%%%%%%%%%%%%%%%%%%
t1=linspace(0,1,territorySide+1);%vector between 0 and 1
NareX=-sin(2*pi*t1+(pi/territorySide));%node X coordinates with phaze shift
NareaY=-cos(2*pi*t1+(pi/territorySide));%node Y coordinates with phaze shift
territoryArea.arX=((((NareX-min(NareX))/(max(NareX)- min(NareX)))*2)-1)*(territorySize.W/2);%normalize  and schale X
territoryArea.arY=((((NareaY-min(NareaY))/(max(NareaY)- min(NareaY)))*2)-1)*(territorySize.H/2);%normalize and schale Y
  
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%-----------simulation area-----------%%%%%%%%%%%%%%%%%%%%%%
t2=linspace(0,1,AreaSide+1);%
areaX=-sin(2*pi*t2+(pi/AreaSide));
areaY=-cos(2*pi*t2+(pi/AreaSide));
areaX=((((areaX-min(areaX))/(max(areaX)- min(areaX)))*2)-1)*(AreaSize.W/2);%normalize  and schale X
areaY=((((areaY-min(areaY))/(max(areaY)- min(areaY)))*2)-1)*(AreaSize.H/2);%normalize and schale Y
poorareaNet.x=areaX;
poorareaNet.y=areaY;
[areaNet.arX,areaNet.arY]=divider(areaX,areaY,netSize);
%%


 for k1=1:netSize
  r1=unifrnd(0,1);
  r2=randi(length(areaNet.arX),1);
  SensorNet(k1).x=r1*areaNet.arX(r2 ) ;
  SensorNet(k1).y=r1*areaNet.arY(r2 ) ;
  
 end
 SensorNet(k1+1).x=0;
 SensorNet(k1+1).y=0;


 
 
end