%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% wirlles sensor libary(Energy enhancment based):                       %
% devloped in Iran(ardeil)                                              %
%Copyright (C) 2016(1395) by moussa hasanzadeh from noavarangermi group.%
% All rights reserved.                                                  %
% programed in mathlab 2012                                             %
% site:https://www.noavarangermi.ir                                     %
% Email:noavarangermi@gmail.com                                         %
% phone number:+98 9194751295 , +98 9365442247                          %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% --otherdescription--%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% you can make your method and comlpare with other methos used here                          %
%all methods are tested.                                                                     %
%after  make your method eamil  it to us to publish it with your name                        %
% if your algoritim was beter we can use it as standard  method in  our library              %
% then we need to have your source code to check it, we will not publish your                %
% source code, only pcode like pcode('method2.m')                                            %
% but if you dont want email your source code then you can pcode but we use                  %
% it as a untrusted methed ! devloped by your name                                           %
%we have  a document with the library said how you can devlop this library                   %
%only by method! but if you can have som sugjection for  add some new property send it to us %
%then we can write a method for you, if you want please send:email:noavarangermi@gmail.com   %
%or  Contact : +98 9194751295 , +98 9365442247                                               % 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% --otherdescription--%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
% *%  3d wirless network*



clc;
clear;
close all;
%%
 addpath(genpath(fullfile(cd,'mainf')));
 warning('off', 'MATLAB:xlswrite:AddSheet');
%%
%%%%%%%%%%%%%%%%%%--net creater----Energy parameters----control parameters--%%%%%%%%%%%%%%%
for f1=1
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%--net creater--%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
global AreaSize;
AreaSize.W=200;%width or horizontal  diagonal 
AreaSize.H=200;%height or vertical  diagonal 
AreaSide=30;%area figure(squar or circle or polygon )
territorySide=30;%territory figure(squar or circle or polygon )
netSize=200;%Number of Nodes in the field
area=(AreaSize.W+AreaSize.H)/2; 
terrSizeControl=(area+netSize)/100;
if terrSizeControl>6
terrSizeControl=6;
end
if terrSizeControl<1
terrSizeControl=1;
end

territorySize.W=AreaSize.W/terrSizeControl;%width or horizontal  diagonal 
territorySize.H=AreaSize.H/terrSizeControl;%height or vertical  diagonal 
sink.x=0;
sink.y=0;


[SensorNet,areaNet,poorareaNet,territoryArea]=WsnNet(AreaSize,AreaSide,netSize,territorySize,territorySide) ;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%--net creater--%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%

  %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  Energy parameter %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
global E0;
E0=0.5;

%Eelec=Etx=Erx
ETX=50*0.000000001;
ERX=50*0.000000001;
%Transmit Amplifier types
Efs=10*0.000000000001;
Emp=0.0013*0.000000000001;
%Data Aggregation Energy
EDA=5*0.000000001;
leachequalityE=(.10*netSize*E0)/netSize;%dispensation  of ch Energy between all nodes campared with the leach
residualEnergy=netSize*E0+leachequalityE;% clculation of resiual energy
homogMaxEnergy=leachequalityE+E0;
unhomogMaxEnergy=E0*2;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  Energy parameter %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  control parameter %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
d0=sqrt(Efs/Emp);
rmax=8000;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  control parameter %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
end

% special for orbital networks
global radius;
global orbitNum;
global nerkh;
global areanum;
global orbitSinkN;
orbitNum=2;%number of orbit
areanum=5;%number of area
orbitSinkN=areanum*orbitNum+1;%clusters
radius=(AreaSize.W+AreaSize.H)/2;%orbit radios
nerkh=(radius-d0)/(orbitNum-1);%area unit seting



  
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Visual effects %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
colorJ=jet(100);
global Cl_E_ind;
Cl_E_ind=[colorJ,linspace(0,E0+leachequalityE,100)'];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Visual effects %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%--initializaion--%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for f2=1:netSize
    S(f2).x=SensorNet(f2).x;
    S(f2).y=SensorNet(f2).y;
    S(f2).E=E0+leachequalityE;
    S(f2).type=1;%normal node
    S(f2).fam=1;
    S(f2).index=f2;
    S(f2).degree=1;
    S(f2).forbid=0;
    S(f2).wakeUp=1;
    S(f2).region=1;
    S(f2).ch=netSize+1;
    S(f2).chd=norm([S(f2).x,S(f2).y]-[SensorNet(netSize+1).x,SensorNet(netSize+1).y]);%distance between sensor and and sink
    S(f2).chS= S(f2).chd;%distance between sensor and sink 
    S(f2).color=Cl_E_ind( (find( S(f2).E==Cl_E_ind(:,4) | S(f2).E< Cl_E_ind(:,4),1,'first')),1:3 );
    S(f2).outSide=0;
    plot( S(f2).x, S(f2).y,'ro');hold on
end

for f3=1
S(netSize+1).x=SensorNet(netSize+1).x;
S(netSize+1).y=SensorNet(netSize+1).y;
S(netSize+1).index=netSize+1;
S(netSize+1).forbid=1;
S(netSize+1).wakeUp=1;
S(netSize+1).type=3;
S(netSize+1).fam=0;
S(netSize+1).ch=netSize+1;
S(netSize+1).E=1000;
S(netSize+1).outSide=0;
S(netSize+1).chforb=1;
netDist=pdist2( [[S.x];[S.y]]',[[S.x];[S.y]]');%distance bitween all nodes

end
%%




%for r=rmax
% global AreaSize;
% global radius;
% global orbitNum;
% global nerkh;
% global areanum;
% global orbitSinkN;


r=radius;
r1=d0;
r2=radius-d0;

Tr1=0.8;
Tr2=1.2;
uintEreaNet.x=poorareaNet.x/AreaSize.W;
uintEreaNet.y=poorareaNet.y/AreaSize.H;
 
t2=linspace(0,1,areanum+1);
 areaIntSec=exp(-1j*(2*pi*t2+(pi/areanum)))/2;
xErea=[real(areaIntSec*Tr1);real(areaIntSec*Tr2)];
yErar=[imag(areaIntSec*Tr1) ;imag(areaIntSec*Tr2)];

for kk=1:length(t2)
[intersPoints.x(kk),intersPoints.y(kk)]=polyxpoly(xErea(:,kk), yErar(:,kk),  uintEreaNet.x,uintEreaNet.y);
end
 
[uintEreaNet1,indexOnPoly,indexOnPolyNeibour]=interpolPoint( intersPoints,uintEreaNet);
plot(uintEreaNet1.x*r1,uintEreaNet1.y*r1,'b-');hold on
plot(uintEreaNet1.x(indexOnPoly)*r1,uintEreaNet1.y(indexOnPoly)*r1,'b.','markerfacecolor','k');hold on

for rne=r1+nerkh:nerkh:r
plot(uintEreaNet1.x*rne,uintEreaNet1.y*rne,'b--');hold on
fill3(uintEreaNet1.x*rne,uintEreaNet1.y*rne,(uintEreaNet1.x.^2*rne+uintEreaNet1.y.^2*rne)*0-0.002,'c');hold on
plot(uintEreaNet1.x(indexOnPoly)*rne,uintEreaNet1.y(indexOnPoly)*rne,'b.','markerfacecolor','k');hold on
end
plot([uintEreaNet1.x(indexOnPoly)*r1;uintEreaNet1.x(indexOnPoly)*r],[uintEreaNet1.y(indexOnPoly)*r1;uintEreaNet1.y(indexOnPoly)*r ],'k-','markerfacecolor','k');hold on
view(3)
grid on; box off;
camzoom(2)
fill3([uintEreaNet1.x*r1*1.2],uintEreaNet1.y*r1*1.2,-((uintEreaNet1.x*r1/50).^2+(uintEreaNet1.y*r1/50 ).^2),'c');hold on
plot3([uintEreaNet1.x(indexOnPoly)*r1;uintEreaNet1.x(indexOnPoly)*r1*1.2],[uintEreaNet1.y(indexOnPoly)*r1;uintEreaNet1.y(indexOnPoly)*r1*1.2],[((uintEreaNet1.x(indexOnPoly)*r1).^2+(uintEreaNet1.y(indexOnPoly)*r1 ).^2)*0;-((uintEreaNet1.x(indexOnPoly)*r1/50).^2+(uintEreaNet1.y(indexOnPoly)*r1/50 ).^2)],'r-.');hold on
zlim([-1,1]);

% surf(peaks)
% axis vis3d
orbital
